// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.
#line 1 "parse/thrifty.yy" // lalr1.cc:404

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#define __STDC_LIMIT_MACROS
#define __STDC_FORMAT_MACROS

#include <cassert>
#include <stdio.h>
#include <inttypes.h>
#include <limits.h>
#include <stack>
#include <utility>

#include <boost/optional.hpp>

#include <thrift/compiler/ast/t_scope.h>
#include <thrift/compiler/ast/t_union.h>
#include <thrift/compiler/parse/parsing_driver.h>
#include <thrift/compiler/ast/t_container.h>

/**
 * Note macro expansion because this is different between OSS and internal
 * build, sigh.
 */
#include THRIFTY_HH

/**
 * Declare fbthrift_compiler_parse_lex() so we can use it.
 */
YY_DECL;
#define yylex fbthrift_compiler_parse_lex

namespace apache {
namespace thrift {
namespace compiler {
namespace {

// Assume ownership of a pointer.
template <typename T>
std::unique_ptr<T> own(T* ptr) {
  return std::unique_ptr<T>(ptr);
}

} // namespace
} // namespace compiler
} // namespace thrift
} // namespace apache


#line 110 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "thrifty.hh"

// User implementation prologue.

#line 124 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:412


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 95 "parse/thrifty.yy" // lalr1.cc:479
namespace apache { namespace thrift { namespace compiler { namespace yy {
#line 210 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:479

  /// Build a parser object.
  parser::parser (apache::thrift::compiler::parsing_driver& driver_yyarg, apache::thrift::compiler::yyscan_t raw_scanner_yyarg, YYSTYPE * yylval_param_yyarg, YYLTYPE * yylloc_param_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg),
      raw_scanner (raw_scanner_yyarg),
      yylval_param (yylval_param_yyarg),
      yylloc_param (yylloc_param_yyarg)
  {}

  parser::~parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
  parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  parser::symbol_number_type
  parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 6: // tok_bool_constant
      case 71: // CommaOrSemicolonOptional
        value.move< bool > (that.value);
        break;

      case 114: // FieldId
        value.move< boost::optional<t_field_id> > (that.value);
        break;

      case 8: // tok_dub_constant
      case 81: // Double
        value.move< double > (that.value);
        break;

      case 80: // Integer
        value.move< int64_t > (that.value);
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 68: // FieldTypeIdentifier
      case 69: // Identifier
      case 135: // IntOrLiteral
        value.move< std::string > (that.value);
        break;

      case 131: // Annotation
        value.move< t_annotation* > (that.value);
        break;

      case 129: // Annotations
      case 130: // AnnotationList
        value.move< t_annotations* > (that.value);
        break;

      case 87: // Const
      case 134: // StructuredAnnotation
        value.move< t_const* > (that.value);
        break;

      case 88: // ConstValue
      case 89: // ConstList
      case 90: // ConstListContents
      case 91: // ConstMap
      case 92: // ConstMapContents
      case 93: // ConstStruct
      case 95: // ConstStructContents
      case 116: // FieldValue
        value.move< t_const_value* > (that.value);
        break;

      case 125: // ContainerType
      case 126: // MapType
      case 127: // SetType
      case 128: // ListType
        value.move< t_container* > (that.value);
        break;

      case 76: // DefinitionAttrs
        value.move< t_def_attrs* > (that.value);
        break;

      case 5: // tok_doctext
      case 72: // CaptureDocText
        value.move< t_doc > (that.value);
        break;

      case 83: // Enum
        value.move< t_enum* > (that.value);
        break;

      case 85: // EnumValueAnnotated
      case 86: // EnumValue
        value.move< t_enum_value* > (that.value);
        break;

      case 84: // EnumValueList
        value.move< t_enum_value_list* > (that.value);
        break;

      case 101: // ErrorBlame
        value.move< t_error_blame > (that.value);
        break;

      case 100: // ErrorKind
        value.move< t_error_kind > (that.value);
        break;

      case 99: // ErrorSafety
        value.move< t_error_safety > (that.value);
        break;

      case 98: // Exception
        value.move< t_exception* > (that.value);
        break;

      case 112: // Field
      case 113: // FieldAnnotated
        value.move< t_field* > (that.value);
        break;

      case 111: // FieldList
        value.move< t_field_list* > (that.value);
        break;

      case 115: // FieldQualifier
        value.move< t_field_qualifier > (that.value);
        break;

      case 106: // Function
      case 107: // FunctionAnnotated
      case 108: // Performs
        value.move< t_function* > (that.value);
        break;

      case 105: // FunctionList
        value.move< t_function_list* > (that.value);
        break;

      case 109: // FunctionQualifier
        value.move< t_function_qualifier > (that.value);
        break;

      case 104: // Interaction
        value.move< t_interaction* > (that.value);
        break;

      case 78: // DefinitionAnnotated
      case 79: // Definition
        value.move< t_named* > (that.value);
        break;

      case 124: // BaseType
        value.move< t_ref<t_base_type> > (that.value);
        break;

      case 103: // Extends
        value.move< t_ref<t_service> > (that.value);
        break;

      case 102: // Service
        value.move< t_service* > (that.value);
        break;

      case 120: // ResponseAndSinkReturnType
      case 121: // SinkReturnType
        value.move< t_sink* > (that.value);
        break;

      case 118: // ResponseAndStreamReturnType
      case 119: // StreamReturnType
        value.move< t_stream_response* > (that.value);
        break;

      case 96: // Struct
        value.move< t_struct* > (that.value);
        break;

      case 132: // StructuredAnnotations
      case 133: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (that.value);
        break;

      case 110: // MaybeThrows
        value.move< t_throws* > (that.value);
        break;

      case 94: // ConstStructType
      case 117: // FunctionType
      case 123: // FieldType
        value.move< t_type_ref > (that.value);
        break;

      case 82: // Typedef
        value.move< t_typedef* > (that.value);
        break;

      case 122: // SinkFieldType
        value.move< t_typethrowspair > (that.value);
        break;

      case 97: // Union
        value.move< t_union* > (that.value);
        break;

      case 7: // tok_int_constant
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 6: // tok_bool_constant
      case 71: // CommaOrSemicolonOptional
        value.copy< bool > (that.value);
        break;

      case 114: // FieldId
        value.copy< boost::optional<t_field_id> > (that.value);
        break;

      case 8: // tok_dub_constant
      case 81: // Double
        value.copy< double > (that.value);
        break;

      case 80: // Integer
        value.copy< int64_t > (that.value);
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 68: // FieldTypeIdentifier
      case 69: // Identifier
      case 135: // IntOrLiteral
        value.copy< std::string > (that.value);
        break;

      case 131: // Annotation
        value.copy< t_annotation* > (that.value);
        break;

      case 129: // Annotations
      case 130: // AnnotationList
        value.copy< t_annotations* > (that.value);
        break;

      case 87: // Const
      case 134: // StructuredAnnotation
        value.copy< t_const* > (that.value);
        break;

      case 88: // ConstValue
      case 89: // ConstList
      case 90: // ConstListContents
      case 91: // ConstMap
      case 92: // ConstMapContents
      case 93: // ConstStruct
      case 95: // ConstStructContents
      case 116: // FieldValue
        value.copy< t_const_value* > (that.value);
        break;

      case 125: // ContainerType
      case 126: // MapType
      case 127: // SetType
      case 128: // ListType
        value.copy< t_container* > (that.value);
        break;

      case 76: // DefinitionAttrs
        value.copy< t_def_attrs* > (that.value);
        break;

      case 5: // tok_doctext
      case 72: // CaptureDocText
        value.copy< t_doc > (that.value);
        break;

      case 83: // Enum
        value.copy< t_enum* > (that.value);
        break;

      case 85: // EnumValueAnnotated
      case 86: // EnumValue
        value.copy< t_enum_value* > (that.value);
        break;

      case 84: // EnumValueList
        value.copy< t_enum_value_list* > (that.value);
        break;

      case 101: // ErrorBlame
        value.copy< t_error_blame > (that.value);
        break;

      case 100: // ErrorKind
        value.copy< t_error_kind > (that.value);
        break;

      case 99: // ErrorSafety
        value.copy< t_error_safety > (that.value);
        break;

      case 98: // Exception
        value.copy< t_exception* > (that.value);
        break;

      case 112: // Field
      case 113: // FieldAnnotated
        value.copy< t_field* > (that.value);
        break;

      case 111: // FieldList
        value.copy< t_field_list* > (that.value);
        break;

      case 115: // FieldQualifier
        value.copy< t_field_qualifier > (that.value);
        break;

      case 106: // Function
      case 107: // FunctionAnnotated
      case 108: // Performs
        value.copy< t_function* > (that.value);
        break;

      case 105: // FunctionList
        value.copy< t_function_list* > (that.value);
        break;

      case 109: // FunctionQualifier
        value.copy< t_function_qualifier > (that.value);
        break;

      case 104: // Interaction
        value.copy< t_interaction* > (that.value);
        break;

      case 78: // DefinitionAnnotated
      case 79: // Definition
        value.copy< t_named* > (that.value);
        break;

      case 124: // BaseType
        value.copy< t_ref<t_base_type> > (that.value);
        break;

      case 103: // Extends
        value.copy< t_ref<t_service> > (that.value);
        break;

      case 102: // Service
        value.copy< t_service* > (that.value);
        break;

      case 120: // ResponseAndSinkReturnType
      case 121: // SinkReturnType
        value.copy< t_sink* > (that.value);
        break;

      case 118: // ResponseAndStreamReturnType
      case 119: // StreamReturnType
        value.copy< t_stream_response* > (that.value);
        break;

      case 96: // Struct
        value.copy< t_struct* > (that.value);
        break;

      case 132: // StructuredAnnotations
      case 133: // NonEmptyStructuredAnnotationList
        value.copy< t_struct_annotations* > (that.value);
        break;

      case 110: // MaybeThrows
        value.copy< t_throws* > (that.value);
        break;

      case 94: // ConstStructType
      case 117: // FunctionType
      case 123: // FieldType
        value.copy< t_type_ref > (that.value);
        break;

      case 82: // Typedef
        value.copy< t_typedef* > (that.value);
        break;

      case 122: // SinkFieldType
        value.copy< t_typethrowspair > (that.value);
        break;

      case 97: // Union
        value.copy< t_union* > (that.value);
        break;

      case 7: // tok_int_constant
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex (driver, raw_scanner, yylval_param, yylloc_param));
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 6: // tok_bool_constant
      case 71: // CommaOrSemicolonOptional
        yylhs.value.build< bool > ();
        break;

      case 114: // FieldId
        yylhs.value.build< boost::optional<t_field_id> > ();
        break;

      case 8: // tok_dub_constant
      case 81: // Double
        yylhs.value.build< double > ();
        break;

      case 80: // Integer
        yylhs.value.build< int64_t > ();
        break;

      case 3: // tok_identifier
      case 4: // tok_literal
      case 68: // FieldTypeIdentifier
      case 69: // Identifier
      case 135: // IntOrLiteral
        yylhs.value.build< std::string > ();
        break;

      case 131: // Annotation
        yylhs.value.build< t_annotation* > ();
        break;

      case 129: // Annotations
      case 130: // AnnotationList
        yylhs.value.build< t_annotations* > ();
        break;

      case 87: // Const
      case 134: // StructuredAnnotation
        yylhs.value.build< t_const* > ();
        break;

      case 88: // ConstValue
      case 89: // ConstList
      case 90: // ConstListContents
      case 91: // ConstMap
      case 92: // ConstMapContents
      case 93: // ConstStruct
      case 95: // ConstStructContents
      case 116: // FieldValue
        yylhs.value.build< t_const_value* > ();
        break;

      case 125: // ContainerType
      case 126: // MapType
      case 127: // SetType
      case 128: // ListType
        yylhs.value.build< t_container* > ();
        break;

      case 76: // DefinitionAttrs
        yylhs.value.build< t_def_attrs* > ();
        break;

      case 5: // tok_doctext
      case 72: // CaptureDocText
        yylhs.value.build< t_doc > ();
        break;

      case 83: // Enum
        yylhs.value.build< t_enum* > ();
        break;

      case 85: // EnumValueAnnotated
      case 86: // EnumValue
        yylhs.value.build< t_enum_value* > ();
        break;

      case 84: // EnumValueList
        yylhs.value.build< t_enum_value_list* > ();
        break;

      case 101: // ErrorBlame
        yylhs.value.build< t_error_blame > ();
        break;

      case 100: // ErrorKind
        yylhs.value.build< t_error_kind > ();
        break;

      case 99: // ErrorSafety
        yylhs.value.build< t_error_safety > ();
        break;

      case 98: // Exception
        yylhs.value.build< t_exception* > ();
        break;

      case 112: // Field
      case 113: // FieldAnnotated
        yylhs.value.build< t_field* > ();
        break;

      case 111: // FieldList
        yylhs.value.build< t_field_list* > ();
        break;

      case 115: // FieldQualifier
        yylhs.value.build< t_field_qualifier > ();
        break;

      case 106: // Function
      case 107: // FunctionAnnotated
      case 108: // Performs
        yylhs.value.build< t_function* > ();
        break;

      case 105: // FunctionList
        yylhs.value.build< t_function_list* > ();
        break;

      case 109: // FunctionQualifier
        yylhs.value.build< t_function_qualifier > ();
        break;

      case 104: // Interaction
        yylhs.value.build< t_interaction* > ();
        break;

      case 78: // DefinitionAnnotated
      case 79: // Definition
        yylhs.value.build< t_named* > ();
        break;

      case 124: // BaseType
        yylhs.value.build< t_ref<t_base_type> > ();
        break;

      case 103: // Extends
        yylhs.value.build< t_ref<t_service> > ();
        break;

      case 102: // Service
        yylhs.value.build< t_service* > ();
        break;

      case 120: // ResponseAndSinkReturnType
      case 121: // SinkReturnType
        yylhs.value.build< t_sink* > ();
        break;

      case 118: // ResponseAndStreamReturnType
      case 119: // StreamReturnType
        yylhs.value.build< t_stream_response* > ();
        break;

      case 96: // Struct
        yylhs.value.build< t_struct* > ();
        break;

      case 132: // StructuredAnnotations
      case 133: // NonEmptyStructuredAnnotationList
        yylhs.value.build< t_struct_annotations* > ();
        break;

      case 110: // MaybeThrows
        yylhs.value.build< t_throws* > ();
        break;

      case 94: // ConstStructType
      case 117: // FunctionType
      case 123: // FieldType
        yylhs.value.build< t_type_ref > ();
        break;

      case 82: // Typedef
        yylhs.value.build< t_typedef* > ();
        break;

      case 122: // SinkFieldType
        yylhs.value.build< t_typethrowspair > ();
        break;

      case 97: // Union
        yylhs.value.build< t_union* > ();
        break;

      case 7: // tok_int_constant
        yylhs.value.build< uint64_t > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 304 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Program -> Headers DefinitionList");
      driver.clear_doctext();
    }
#line 1120 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 3:
#line 318 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = std::move(yystack_[0].value.as< std::string > ()); }
#line 1126 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 4:
#line 321 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = std::move(yystack_[0].value.as< std::string > ()); }
#line 1132 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 5:
#line 323 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "package"; }
#line 1138 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 6:
#line 324 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "sink"; }
#line 1144 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 7:
#line 325 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "oneway"; }
#line 1150 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 8:
#line 326 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "readonly"; }
#line 1156 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 9:
#line 327 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "idempotent"; }
#line 1162 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 10:
#line 328 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "safe"; }
#line 1168 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 11:
#line 329 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "transient"; }
#line 1174 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 12:
#line 330 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "stateful"; }
#line 1180 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 13:
#line 331 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "permanent"; }
#line 1186 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 14:
#line 332 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "server"; }
#line 1192 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 15:
#line 333 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< std::string > () = "client"; }
#line 1198 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 16:
#line 336 "parse/thrifty.yy" // lalr1.cc:859
    {}
#line 1204 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 17:
#line 337 "parse/thrifty.yy" // lalr1.cc:859
    {}
#line 1210 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 18:
#line 340 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< bool > () = true; }
#line 1216 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 19:
#line 341 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< bool > () = false; }
#line 1222 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 20:
#line 343 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_doc > () = driver.capture_doctext(); }
#line 1228 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 21:
#line 346 "parse/thrifty.yy" // lalr1.cc:859
    { driver.clear_doctext(); }
#line 1234 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 22:
#line 351 "parse/thrifty.yy" // lalr1.cc:859
    { driver.debug("HeaderList -> HeaderList Header"); }
#line 1240 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 23:
#line 352 "parse/thrifty.yy" // lalr1.cc:859
    { driver.debug("HeaderList -> "); }
#line 1246 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 24:
#line 356 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Header -> tok_include tok_literal");
      driver.add_include(std::move(yystack_[0].value.as< std::string > ()));
    }
#line 1255 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 25:
#line 361 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Header -> tok_package tok_literal");
      driver.set_package(std::move(yystack_[0].value.as< std::string > ()));
    }
#line 1264 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 26:
#line 366 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Header -> tok_namespace Identifier Identifier");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(std::move(yystack_[1].value.as< std::string > ()), std::move(yystack_[0].value.as< std::string > ()));
      }
    }
#line 1275 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 27:
#line 373 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Header -> tok_namespace Identifier tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(std::move(yystack_[1].value.as< std::string > ()), std::move(yystack_[0].value.as< std::string > ()));
      }
    }
#line 1286 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 28:
#line 380 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Header -> tok_cpp_include tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_cpp_include(yystack_[0].value.as< std::string > ());
      }
    }
#line 1297 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 29:
#line 387 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Header -> tok_hs_include tok_literal");
      // Do nothing. This syntax is handled by the hs compiler
    }
#line 1306 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 30:
#line 394 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("DefinitionAttrs -> CaptureDocText StructuredAnnotations");
      yylhs.value.as< t_def_attrs* > () = nullptr;
      if (yystack_[1].value.as< t_doc > () || yystack_[0].value.as< t_struct_annotations* > () != nullptr) {
        driver.avoid_tokens_loc(yylhs.location, {{!yystack_[1].value.as< t_doc > (), yystack_[0].location}}, {});
        yylhs.value.as< t_def_attrs* > () = new t_def_attrs{std::move(yystack_[1].value.as< t_doc > ()), own(yystack_[0].value.as< t_struct_annotations* > ())};
      }
    }
#line 1319 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 31:
#line 405 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("DefinitionList -> DefinitionList DefinitionAnnotated "
        "CommaOrSemicolonOptional");
      driver.add_def(own(yystack_[1].value.as< t_named* > ()));
    }
#line 1329 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 32:
#line 410 "parse/thrifty.yy" // lalr1.cc:859
    { driver.debug("DefinitionList -> "); }
#line 1335 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 33:
#line 414 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Definition -> DefinitionAttrs Definition Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as< t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as< t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as< t_named* > () = yystack_[1].value.as< t_named* > ();
      driver.set_attributes(*yylhs.value.as< t_named* > (), own(yystack_[2].value.as< t_def_attrs* > ()), own(yystack_[0].value.as< t_annotations* > ()), yylhs.location);
    }
#line 1346 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 34:
#line 422 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_typedef* > (); }
#line 1352 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 35:
#line 423 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_enum* > (); }
#line 1358 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 36:
#line 424 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_const* > (); }
#line 1364 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 37:
#line 425 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_struct* > (); }
#line 1370 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 38:
#line 426 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_union* > (); }
#line 1376 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 39:
#line 427 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_exception* > (); }
#line 1382 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 40:
#line 428 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_service* > (); }
#line 1388 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 41:
#line 429 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_named* > () = yystack_[0].value.as< t_interaction* > (); }
#line 1394 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 42:
#line 433 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Integer -> tok_int_constant");
      yylhs.value.as< int64_t > () = driver.to_int(yystack_[0].value.as< uint64_t > ());
    }
#line 1403 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 43:
#line 438 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Integer -> + tok_int_constant");
      yylhs.value.as< int64_t > () = driver.to_int(yystack_[0].value.as< uint64_t > ());
    }
#line 1412 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 44:
#line 443 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Integer -> - tok_int_constant");
      yylhs.value.as< int64_t > () = driver.to_int(yystack_[0].value.as< uint64_t > (), true);
    }
#line 1421 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 45:
#line 450 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Double -> tok_dub_constant");
      yylhs.value.as< double > () = yystack_[0].value.as< double > ();
    }
#line 1430 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 46:
#line 455 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Double -> + tok_dub_constant");
      yylhs.value.as< double > () = yystack_[0].value.as< double > ();
    }
#line 1439 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 47:
#line 460 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Double -> - tok_dub_constant");
      yylhs.value.as< double > () = -yystack_[0].value.as< double > ();
    }
#line 1448 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 48:
#line 467 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("TypeDef => tok_typedef FieldType Identifier");
      yylhs.value.as< t_typedef* > () = new t_typedef(driver.program, std::move(yystack_[0].value.as< std::string > ()), std::move(yystack_[1].value.as< t_type_ref > ()));
      yylhs.value.as< t_typedef* > ()->set_lineno(yystack_[0].location.end.line);
    }
#line 1458 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 49:
#line 475 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Enum => tok_enum Identifier { EnumValueList }");
      yylhs.value.as< t_enum* > () = new t_enum(driver.program, std::move(yystack_[3].value.as< std::string > ()));
      yylhs.value.as< t_enum* > ()->set_values(std::move(*own(yystack_[1].value.as< t_enum_value_list* > ())));
      yylhs.value.as< t_enum* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 1469 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 50:
#line 484 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("EnumValueList EnumValueAnnotated CommaOrSemicolonOptional");
      yylhs.value.as< t_enum_value_list* > () = yystack_[2].value.as< t_enum_value_list* > ();
      yylhs.value.as< t_enum_value_list* > ()->emplace_back(own(yystack_[1].value.as< t_enum_value* > ()));
    }
#line 1479 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 51:
#line 490 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("EnumValueList -> ");
      yylhs.value.as< t_enum_value_list* > () = new t_enum_value_list;
    }
#line 1488 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 52:
#line 497 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("DefinitionAttrs EnumValue Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as< t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as< t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as< t_enum_value* > () = yystack_[1].value.as< t_enum_value* > ();
      driver.set_attributes(*yylhs.value.as< t_enum_value* > (), own(yystack_[2].value.as< t_def_attrs* > ()), own(yystack_[0].value.as< t_annotations* > ()), yylhs.location);
    }
#line 1499 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 53:
#line 506 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("EnumValue -> Identifier = Integer");
      yylhs.value.as< t_enum_value* > () = new t_enum_value(std::move(yystack_[2].value.as< std::string > ()));
      yylhs.value.as< t_enum_value* > ()->set_value(driver.to_enum_value(yystack_[0].value.as< int64_t > ()));
      yylhs.value.as< t_enum_value* > ()->set_lineno(yystack_[2].location.end.line);
    }
#line 1510 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 54:
#line 513 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("EnumValue -> Identifier");
      yylhs.value.as< t_enum_value* > () = new t_enum_value(std::move(yystack_[0].value.as< std::string > ()));
      yylhs.value.as< t_enum_value* > ()->set_lineno(yystack_[0].location.end.line);
    }
#line 1520 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 55:
#line 521 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Const => tok_const FieldType Identifier = ConstValue");
      yylhs.value.as< t_const* > () = new t_const(driver.program, std::move(yystack_[3].value.as< t_type_ref > ()), std::move(yystack_[2].value.as< std::string > ()), own(yystack_[0].value.as< t_const_value* > ()));
      yylhs.value.as< t_const* > ()->set_lineno(yystack_[2].location.end.line);
    }
#line 1530 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 56:
#line 529 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => tok_bool_constant");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_bool(yystack_[0].value.as< bool > ());
    }
#line 1540 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 57:
#line 535 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => Integer");
      yylhs.value.as< t_const_value* > () = driver.to_const_value(yystack_[0].value.as< int64_t > ()).release();
    }
#line 1549 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 58:
#line 540 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => Double");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_double(yystack_[0].value.as< double > ());
    }
#line 1559 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 59:
#line 546 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => tok_literal");
      yylhs.value.as< t_const_value* > () = new t_const_value(yystack_[0].value.as< std::string > ());
    }
#line 1568 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 60:
#line 551 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => Identifier");
      yylhs.value.as< t_const_value* > () = driver.copy_const_value(yystack_[0].value.as< std::string > ()).release();
    }
#line 1577 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 61:
#line 556 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => ConstList");
      yylhs.value.as< t_const_value* > () = yystack_[0].value.as< t_const_value* > ();
    }
#line 1586 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 62:
#line 561 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => ConstMap");
      yylhs.value.as< t_const_value* > () = yystack_[0].value.as< t_const_value* > ();
    }
#line 1595 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 63:
#line 566 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstValue => ConstStruct");
      yylhs.value.as< t_const_value* > () = yystack_[0].value.as< t_const_value* > ();
    }
#line 1604 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 64:
#line 573 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstList => [ ConstListContents CommaOrSemicolonOptional ]");
      yylhs.value.as< t_const_value* > () = yystack_[2].value.as< t_const_value* > ();
    }
#line 1613 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 65:
#line 578 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstList => [ ]");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_list();
    }
#line 1623 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 66:
#line 586 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstListContents => ConstListContents CommaOrSemicolon ConstValue");
      yylhs.value.as< t_const_value* > () = yystack_[2].value.as< t_const_value* > ();
      yylhs.value.as< t_const_value* > ()->add_list(own(yystack_[0].value.as< t_const_value* > ()));
    }
#line 1633 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 67:
#line 592 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstListContents => ConstValue");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_list();
      yylhs.value.as< t_const_value* > ()->add_list(own(yystack_[0].value.as< t_const_value* > ()));
    }
#line 1644 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 68:
#line 601 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstMap => { ConstMapContents CommaOrSemicolonOptional }");
      yylhs.value.as< t_const_value* > () = yystack_[2].value.as< t_const_value* > ();
    }
#line 1653 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 69:
#line 606 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstMap => { }");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_map();
    }
#line 1663 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 70:
#line 614 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstMapContents => ConstMapContents CommaOrSemicolon ConstValue : ConstValue");
      yylhs.value.as< t_const_value* > () = yystack_[4].value.as< t_const_value* > ();
      yylhs.value.as< t_const_value* > ()->add_map(own(yystack_[2].value.as< t_const_value* > ()), own(yystack_[0].value.as< t_const_value* > ()));
    }
#line 1673 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 71:
#line 620 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstMapContents => ConstValue : ConstValue");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_map();
      yylhs.value.as< t_const_value* > ()->add_map(own(yystack_[2].value.as< t_const_value* > ()), own(yystack_[0].value.as< t_const_value* > ()));
    }
#line 1684 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 72:
#line 629 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstStruct => ConstStructType { ConstStructContents CommaOrSemicolonOptional }");
      yylhs.value.as< t_const_value* > () = yystack_[2].value.as< t_const_value* > ();
      yylhs.value.as< t_const_value* > ()->set_ttype(yystack_[4].value.as< t_type_ref > ());
    }
#line 1694 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 73:
#line 635 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstStruct => ConstStructType { }");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_map();
      yylhs.value.as< t_const_value* > ()->set_ttype(yystack_[2].value.as< t_type_ref > ());
    }
#line 1705 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 74:
#line 644 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstStructType -> Identifier");
      yylhs.value.as< t_type_ref > () = driver.new_type_ref(std::move(yystack_[0].value.as< std::string > ()), nullptr, /*is_const=*/true);
    }
#line 1714 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 75:
#line 651 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstStructContents => ConstStructContents CommaOrSemicolon Identifier = ConstValue");
      yylhs.value.as< t_const_value* > () = yystack_[4].value.as< t_const_value* > ();
      yylhs.value.as< t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as< std::string > ()), own(yystack_[0].value.as< t_const_value* > ()));
    }
#line 1724 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 76:
#line 657 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ConstStructContents => Identifier = ConstValue");
      yylhs.value.as< t_const_value* > () = new t_const_value();
      yylhs.value.as< t_const_value* > ()->set_map();
      yylhs.value.as< t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as< std::string > ()), own(yystack_[0].value.as< t_const_value* > ()));
    }
#line 1735 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 77:
#line 666 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Struct => tok_struct Identifier { FieldList }");
      yylhs.value.as< t_struct* > () = new t_struct(driver.program, std::move(yystack_[3].value.as< std::string > ()));
      driver.set_fields(*yylhs.value.as< t_struct* > (), std::move(*own(yystack_[1].value.as< t_field_list* > ())));
      yylhs.value.as< t_struct* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 1746 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 78:
#line 675 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Union => tok_union Identifier { FieldList }");
      yylhs.value.as< t_union* > () = new t_union(driver.program, std::move(yystack_[3].value.as< std::string > ()));
      driver.set_fields(*yylhs.value.as< t_union* > (), std::move(*own(yystack_[1].value.as< t_field_list* > ())));
      yylhs.value.as< t_union* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 1757 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 79:
#line 685 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Exception => ErrorSafety ErrorKind ErrorBlame tok_exception "
        "Identifier { FieldList }");
      // TODO(afuller): Correct resulting source_loc.begin when safety qualifier is omitted.
      yylhs.value.as< t_exception* > () = new t_exception(driver.program, std::move(yystack_[3].value.as< std::string > ()));
      yylhs.value.as< t_exception* > ()->set_safety(yystack_[7].value.as< t_error_safety > ());
      yylhs.value.as< t_exception* > ()->set_kind(yystack_[6].value.as< t_error_kind > ());
      yylhs.value.as< t_exception* > ()->set_blame(yystack_[5].value.as< t_error_blame > ());
      driver.set_fields(*yylhs.value.as< t_exception* > (), std::move(*own(yystack_[1].value.as< t_field_list* > ())));
      yylhs.value.as< t_exception* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 1773 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 80:
#line 698 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_safety > () = t_error_safety::safe;}
#line 1779 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 81:
#line 699 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_safety > () = {}; }
#line 1785 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 82:
#line 702 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_kind > () = t_error_kind::transient; }
#line 1791 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 83:
#line 703 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_kind > () = t_error_kind::stateful; }
#line 1797 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 84:
#line 704 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_kind > () = t_error_kind::permanent; }
#line 1803 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 85:
#line 705 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_kind > () = {}; }
#line 1809 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 86:
#line 708 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_blame > () = t_error_blame::client; }
#line 1815 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 87:
#line 709 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_blame > () = t_error_blame::server; }
#line 1821 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 88:
#line 710 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_error_blame > () = {}; }
#line 1827 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 89:
#line 714 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Service => tok_service Identifier Extends { FunctionList }");
      yylhs.value.as< t_service* > () = new t_service(driver.program, std::move(yystack_[4].value.as< std::string > ()), yystack_[3].value.as< t_ref<t_service> > ());
      driver.set_functions(*yylhs.value.as< t_service* > (), own(yystack_[1].value.as< t_function_list* > ()));
      yylhs.value.as< t_service* > ()->set_lineno(yystack_[4].location.end.line);
    }
#line 1838 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 90:
#line 723 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Extends -> tok_extends Identifier");
      yylhs.value.as< t_ref<t_service> > () = driver.find_service(yystack_[0].value.as< std::string > ());
    }
#line 1847 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 91:
#line 727 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_ref<t_service> > () = nullptr; }
#line 1853 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 92:
#line 731 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Interaction -> tok_interaction Identifier { FunctionList }");
      yylhs.value.as< t_interaction* > () = new t_interaction(driver.program, std::move(yystack_[3].value.as< std::string > ()));
      driver.set_functions(*yylhs.value.as< t_interaction* > (), own(yystack_[1].value.as< t_function_list* > ()));
      yylhs.value.as< t_interaction* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 1864 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 93:
#line 740 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionList -> FunctionList FunctionAnnotated CommaOrSemicolonOptional");
      yystack_[2].value.as< t_function_list* > ()->emplace_back(own(yystack_[1].value.as< t_function* > ()));
      yylhs.value.as< t_function_list* > () = yystack_[2].value.as< t_function_list* > ();
    }
#line 1874 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 94:
#line 746 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionList -> FunctionList Performs CommaOrSemicolon");
      yystack_[2].value.as< t_function_list* > ()->emplace_back(own(yystack_[1].value.as< t_function* > ()));
      yylhs.value.as< t_function_list* > () = yystack_[2].value.as< t_function_list* > ();
    }
#line 1884 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 95:
#line 752 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionList -> ");
      yylhs.value.as< t_function_list* > () = new t_function_list;
    }
#line 1893 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 96:
#line 759 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Function => FunctionQualifier FunctionType Identifier ( FieldList ) MaybeThrows");
      driver.avoid_tokens_loc(
        yylhs.location,
        {{yystack_[6].value.as< t_function_qualifier > () == t_function_qualifier::unspecified, yystack_[5].location}},
        {{yystack_[0].value.as< t_throws* > () == nullptr, yystack_[1].location}});
      yylhs.value.as< t_function* > () = new t_function(driver.program, std::move(yystack_[5].value.as< t_type_ref > ()), std::move(yystack_[4].value.as< std::string > ()));
      yylhs.value.as< t_function* > ()->set_qualifier(yystack_[6].value.as< t_function_qualifier > ());
      driver.set_fields(yylhs.value.as< t_function* > ()->params(), std::move(*own(yystack_[2].value.as< t_field_list* > ())));
      yylhs.value.as< t_function* > ()->set_exceptions(own(yystack_[0].value.as< t_throws* > ()));
      yylhs.value.as< t_function* > ()->set_lineno(yystack_[4].location.end.line);
      // TODO(afuller): Leave the param list unnamed.
      yylhs.value.as< t_function* > ()->params().set_name(yylhs.value.as< t_function* > ()->name() + "_args");
    }
#line 1912 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 97:
#line 776 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionAnnotated => DefinitionAttrs Function Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as< t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as< t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as< t_function* > () = yystack_[1].value.as< t_function* > ();
      driver.set_attributes(*yylhs.value.as< t_function* > (), own(yystack_[2].value.as< t_def_attrs* > ()), own(yystack_[0].value.as< t_annotations* > ()), yylhs.location);
    }
#line 1923 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 98:
#line 785 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Performs => tok_performs FieldType");
      auto& ret = yystack_[0].value.as< t_type_ref > ();
      std::string name = ret.get_type()
          ? "create" + ret.get_type()->get_name()
          : "<interaction placeholder>";
      yylhs.value.as< t_function* > () = new t_function(
        std::move(ret),
        std::move(name),
        std::make_unique<t_paramlist>(driver.program)
      );
      yylhs.value.as< t_function* > ()->set_lineno(driver.scanner->get_lineno());
      yylhs.value.as< t_function* > ()->set_is_interaction_constructor();
    }
#line 1942 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 99:
#line 801 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_function_qualifier > () = t_function_qualifier::one_way; }
#line 1948 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 100:
#line 802 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_function_qualifier > () = t_function_qualifier::idempotent; }
#line 1954 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 101:
#line 803 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_function_qualifier > () = t_function_qualifier::read_only; }
#line 1960 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 102:
#line 804 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_function_qualifier > () = {}; }
#line 1966 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 103:
#line 808 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("MaybeThrows -> tok_throws ( FieldList )");
      yylhs.value.as< t_throws* > () = driver.new_throws(own(yystack_[1].value.as< t_field_list* > ())).release();
    }
#line 1975 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 104:
#line 812 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_throws* > () = nullptr; }
#line 1981 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 105:
#line 816 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FieldList -> FieldAnnotated CommaOrSemicolonOptional");
      yylhs.value.as< t_field_list* > () = yystack_[2].value.as< t_field_list* > ();
      yylhs.value.as< t_field_list* > ()->emplace_back(yystack_[1].value.as< t_field* > ());
    }
#line 1991 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 106:
#line 822 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FieldList -> ");
      yylhs.value.as< t_field_list* > () = new t_field_list;
    }
#line 2000 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 107:
#line 829 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Field => FieldId FieldQualifier FieldType Identifier FieldValue");
      driver.avoid_tokens_loc(yylhs.location, {}, {{yystack_[0].value.as< t_const_value* > () == nullptr, yystack_[1].location}});
      yylhs.value.as< t_field* > () = new t_field(std::move(yystack_[2].value.as< t_type_ref > ()), std::move(yystack_[1].value.as< std::string > ()), yystack_[4].value.as< boost::optional<t_field_id> > ().value_or(0), yystack_[4].value.as< boost::optional<t_field_id> > () != boost::none);
      yylhs.value.as< t_field* > ()->set_qualifier(yystack_[3].value.as< t_field_qualifier > ());
      yylhs.value.as< t_field* > ()->set_default_value(own(yystack_[0].value.as< t_const_value* > ()));
      yylhs.value.as< t_field* > ()->set_lineno(yystack_[1].location.end.line);
    }
#line 2013 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 108:
#line 840 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FieldAnnotated => DefinitionAttrs Field Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as< t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as< t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as< t_field* > () = yystack_[1].value.as< t_field* > ();
      driver.set_attributes(*yylhs.value.as< t_field* > (), own(yystack_[2].value.as< t_def_attrs* > ()), own(yystack_[0].value.as< t_annotations* > ()), yylhs.location);
    }
#line 2024 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 109:
#line 848 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< boost::optional<t_field_id> > () = driver.to_field_id(yystack_[1].value.as< int64_t > ()); }
#line 2030 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 110:
#line 849 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< boost::optional<t_field_id> > () = boost::none; }
#line 2036 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 111:
#line 852 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_field_qualifier > () = t_field_qualifier::required; }
#line 2042 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 112:
#line 853 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_field_qualifier > () = t_field_qualifier::optional; }
#line 2048 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 113:
#line 854 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_field_qualifier > () = {}; }
#line 2054 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 114:
#line 858 "parse/thrifty.yy" // lalr1.cc:859
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as< t_const_value* > () = yystack_[0].value.as< t_const_value* > ();
      } else {
        delete yystack_[0].value.as< t_const_value* > ();
        yylhs.value.as< t_const_value* > () = nullptr;
      }
    }
#line 2067 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 115:
#line 866 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_const_value* > () = nullptr; }
#line 2073 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 116:
#line 870 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionType -> ResponseAndStreamReturnType");
      yylhs.value.as< t_type_ref > () = driver.new_type_ref(own(yystack_[0].value.as< t_stream_response* > ()), nullptr);
    }
#line 2082 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 117:
#line 875 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionType -> ResponseAndSinkReturnType");
      yylhs.value.as< t_type_ref > () = driver.new_type_ref(own(yystack_[0].value.as< t_sink* > ()), nullptr);
    }
#line 2091 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 118:
#line 880 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionType -> FieldType");
      yylhs.value.as< t_type_ref > () = yystack_[0].value.as< t_type_ref > ();
    }
#line 2100 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 119:
#line 885 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FunctionType -> tok_void");
      yylhs.value.as< t_type_ref > () = t_base_type::t_void();
    }
#line 2109 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 120:
#line 892 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ResponseAndStreamReturnType -> FieldType, StreamReturnType");
      yystack_[0].value.as< t_stream_response* > ()->set_first_response_type(std::move(yystack_[2].value.as< t_type_ref > ()));
      yylhs.value.as< t_stream_response* > () = yystack_[0].value.as< t_stream_response* > ();
    }
#line 2119 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 121:
#line 898 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ResponseAndStreamReturnType -> StreamReturnType");
      yylhs.value.as< t_stream_response* > () = yystack_[0].value.as< t_stream_response* > ();
    }
#line 2128 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 122:
#line 905 "parse/thrifty.yy" // lalr1.cc:859
    {
    driver.debug("StreamReturnType -> tok_stream < FieldType MaybeThrows >");
    auto stream_res = std::make_unique<t_stream_response>(std::move(yystack_[2].value.as< t_type_ref > ()));
    stream_res->set_exceptions(own(yystack_[1].value.as< t_throws* > ()));
    yylhs.value.as< t_stream_response* > () = stream_res.release();
  }
#line 2139 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 123:
#line 914 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ResponseAndSinkReturnType -> FieldType, SinkReturnType");
      yystack_[0].value.as< t_sink* > ()->set_first_response_type(std::move(yystack_[2].value.as< t_type_ref > ()));
      yylhs.value.as< t_sink* > () = yystack_[0].value.as< t_sink* > ();
    }
#line 2149 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 124:
#line 920 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ResponseAndSinkReturnType -> SinkReturnType");
      yylhs.value.as< t_sink* > () = yystack_[0].value.as< t_sink* > ();
    }
#line 2158 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 125:
#line 927 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("SinkReturnType -> tok_sink<FieldType, FieldType>");
      auto sink = std::make_unique<t_sink>(std::move(yystack_[3].value.as< t_typethrowspair > ().first), std::move(yystack_[1].value.as< t_typethrowspair > ().first));
      sink->set_sink_exceptions(own(yystack_[3].value.as< t_typethrowspair > ().second));
      sink->set_final_response_exceptions(own(yystack_[1].value.as< t_typethrowspair > ().second));
      yylhs.value.as< t_sink* > () = sink.release();
    }
#line 2170 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 126:
#line 937 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("SinkFieldType => FieldType MaybeThrows");
      yylhs.value.as< t_typethrowspair > () = std::make_pair(yystack_[1].value.as< t_type_ref > (), yystack_[0].value.as< t_throws* > ());
    }
#line 2179 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 127:
#line 944 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FieldType => Identifier Annotations");
      yylhs.value.as< t_type_ref > () = driver.new_type_ref(std::move(yystack_[1].value.as< std::string > ()), own(yystack_[0].value.as< t_annotations* > ()));
    }
#line 2188 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 128:
#line 949 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FieldType -> BaseType");
      yylhs.value.as< t_type_ref > () = driver.new_type_ref(*yystack_[1].value.as< t_ref<t_base_type> > (), own(yystack_[0].value.as< t_annotations* > ()));
    }
#line 2197 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 129:
#line 954 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("FieldType -> ContainerType");
      yylhs.value.as< t_type_ref > () = driver.new_type_ref(own(yystack_[1].value.as< t_container* > ()), own(yystack_[0].value.as< t_annotations* > ()));
    }
#line 2206 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 130:
#line 961 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_string");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_string();
    }
#line 2215 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 131:
#line 966 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_binary");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_binary();
    }
#line 2224 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 132:
#line 971 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_bool");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_bool();
    }
#line 2233 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 133:
#line 976 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_byte");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_byte();
    }
#line 2242 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 134:
#line 981 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_i16");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_i16();
    }
#line 2251 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 135:
#line 986 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_i32");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_i32();
    }
#line 2260 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 136:
#line 991 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_i64");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_i64();
    }
#line 2269 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 137:
#line 996 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_double");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_double();
    }
#line 2278 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 138:
#line 1001 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("BaseType -> tok_float");
      yylhs.value.as< t_ref<t_base_type> > () = &t_base_type::t_float();
    }
#line 2287 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 139:
#line 1007 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_container* > () = yystack_[0].value.as< t_container* > (); }
#line 2293 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 140:
#line 1008 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_container* > () = yystack_[0].value.as< t_container* > (); }
#line 2299 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 141:
#line 1009 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_container* > () = yystack_[0].value.as< t_container* > (); }
#line 2305 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 142:
#line 1013 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("MapType -> tok_map<FieldType, FieldType>");
      yylhs.value.as< t_container* > () = new t_map(std::move(yystack_[3].value.as< t_type_ref > ()), std::move(yystack_[1].value.as< t_type_ref > ()));
    }
#line 2314 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 143:
#line 1020 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("SetType -> tok_set<FieldType>");
      yylhs.value.as< t_container* > () = new t_set(std::move(yystack_[1].value.as< t_type_ref > ()));
    }
#line 2323 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 144:
#line 1027 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("ListType -> tok_list<FieldType>");
      yylhs.value.as< t_container* > () = new t_list(std::move(yystack_[1].value.as< t_type_ref > ()));
    }
#line 2332 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 145:
#line 1034 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Annotations => ( AnnotationList CommaOrSemicolonOptional)");
      yylhs.value.as< t_annotations* > () = yystack_[2].value.as< t_annotations* > ();
    }
#line 2341 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 146:
#line 1039 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Annotations => ( )");
      yylhs.value.as< t_annotations* > () = nullptr;
    }
#line 2350 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 147:
#line 1043 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_annotations* > () = nullptr; }
#line 2356 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 148:
#line 1047 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("NodeAnnotationList => NodeAnnotationList CommaOrSemicolon Annotation");
      yylhs.value.as< t_annotations* > () = yystack_[2].value.as< t_annotations* > ();
      yylhs.value.as< t_annotations* > ()->strings[yystack_[0].value.as< t_annotation* > ()->first] = std::move(yystack_[0].value.as< t_annotation* > ()->second);
      delete yystack_[0].value.as< t_annotation* > ();
    }
#line 2367 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 149:
#line 1054 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("AnnotationList => Annotation");
      /* Just use a dummy structure to hold the annotations. */
      yylhs.value.as< t_annotations* > () = new t_annotations();
      yylhs.value.as< t_annotations* > ()->strings[yystack_[0].value.as< t_annotation* > ()->first] = std::move(yystack_[0].value.as< t_annotation* > ()->second);
      delete yystack_[0].value.as< t_annotation* > ();
    }
#line 2379 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 150:
#line 1064 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Annotation -> Identifier = IntOrLiteral");
      yylhs.value.as< t_annotation* > () = new t_annotation{yystack_[2].value.as< std::string > (), {driver.get_source_range(yylhs.location), yystack_[0].value.as< std::string > ()}};
    }
#line 2388 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 151:
#line 1069 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("Annotation -> Identifier");
      yylhs.value.as< t_annotation* > () = new t_annotation{yystack_[0].value.as< std::string > (), {driver.get_source_range(yylhs.location), "1"}};
    }
#line 2397 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 152:
#line 1076 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("StructuredAnnotations -> NonEmptyStructuredAnnotationList");
      yylhs.value.as< t_struct_annotations* > () = yystack_[0].value.as< t_struct_annotations* > ();
    }
#line 2406 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 153:
#line 1080 "parse/thrifty.yy" // lalr1.cc:859
    { yylhs.value.as< t_struct_annotations* > () = nullptr; }
#line 2412 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 154:
#line 1084 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("NonEmptyStructuredAnnotationList -> NonEmptyStructuredAnnotationList StructuredAnnotation");
      yylhs.value.as< t_struct_annotations* > () = yystack_[1].value.as< t_struct_annotations* > ();
      yylhs.value.as< t_struct_annotations* > ()->emplace_back(yystack_[0].value.as< t_const* > ());
    }
#line 2422 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 155:
#line 1090 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("NonEmptyStructuredAnnotationList ->");
      yylhs.value.as< t_struct_annotations* > () = new t_struct_annotations;
      yylhs.value.as< t_struct_annotations* > ()->emplace_back(yystack_[0].value.as< t_const* > ());
    }
#line 2432 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 156:
#line 1098 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("StructuredAnnotation => @ConstStruct");
      yylhs.value.as< t_const* > () = driver.new_struct_annotation(own(yystack_[0].value.as< t_const_value* > ())).release();
    }
#line 2441 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 157:
#line 1103 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("StructuredAnnotation => @ConstStructType");
      auto value = std::make_unique<t_const_value>();
      value->set_map();
      value->set_ttype(std::move(yystack_[0].value.as< t_type_ref > ()));
      yylhs.value.as< t_const* > () = driver.new_struct_annotation(std::move(value)).release();
    }
#line 2453 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 158:
#line 1113 "parse/thrifty.yy" // lalr1.cc:859
    {
      driver.debug("IntOrLiteral -> tok_literal");
      yylhs.value.as< std::string > () = yystack_[0].value.as< std::string > ();
    }
#line 2462 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 159:
#line 1118 "parse/thrifty.yy" // lalr1.cc:859
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_bool_constant");
      sprintf(buf, "%" PRIi32, yystack_[0].value.as< bool > () ? 1 : 0);
      yylhs.value.as< std::string > () = buf;
    }
#line 2473 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;

  case 160:
#line 1125 "parse/thrifty.yy" // lalr1.cc:859
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> Integer");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as< int64_t > ());
      yylhs.value.as< std::string > () = buf;
    }
#line 2484 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
    break;


#line 2488 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type, const symbol_type&) const
  {
    return YY_("syntax error");
  }


  const short int parser::yypact_ninf_ = -241;

  const signed char parser::yytable_ninf_ = -75;

  const short int
  parser::yypact_[] =
  {
    -241,    11,    57,  -241,    63,    19,    28,    32,    43,    45,
     328,  -241,    46,    -8,    16,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,   198,   328,  -241,    46,  -241,  -241,   378,   328,
     328,   328,   378,   328,   328,    23,  -241,  -241,  -241,  -241,
    -241,  -241,    24,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,    59,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,    38,    56,    74,    23,   328,    23,
      23,  -241,  -241,  -241,    85,    41,    99,   328,   109,   110,
     268,  -241,  -241,  -241,  -241,   -36,   318,   378,   378,   378,
    -241,  -241,  -241,  -241,  -241,   328,   112,  -241,   114,  -241,
    -241,  -241,   117,    16,  -241,  -241,  -241,    76,  -241,   120,
      16,   125,   119,   121,   128,  -241,  -241,   131,   258,   132,
       1,    31,   328,   129,   328,   258,   328,   136,   378,  -241,
    -241,  -241,    36,    16,     6,  -241,   328,    16,  -241,  -241,
    -241,  -241,   148,   208,    71,   105,   126,  -241,  -241,  -241,
    -241,  -241,  -241,    59,  -241,  -241,   378,    61,    16,    16,
    -241,  -241,   142,   143,  -241,  -241,  -241,  -241,   146,  -241,
     140,  -241,   141,   147,    23,    54,  -241,  -241,   151,    23,
    -241,  -241,   149,    16,  -241,  -241,    16,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,    23,   353,  -241,  -241,  -241,
     258,  -241,  -241,  -241,  -241,  -241,   378,    36,  -241,   258,
     258,   154,   258,   152,  -241,  -241,   155,   157,   328,  -241,
    -241,  -241,  -241,   159,   161,  -241,   328,  -241,  -241,   162,
    -241,  -241,  -241,   378,   378,   160,    75,  -241,   167,   258,
     127,   172,   127,  -241,  -241,  -241,   258,  -241,  -241,   168,
     164,   378,  -241,   169,  -241,  -241,  -241,   166,   127,   170,
    -241,  -241,  -241
  };

  const unsigned char
  parser::yydefact_[] =
  {
      23,     0,    32,     1,     0,    20,     0,     0,     0,     0,
       0,    22,   153,    81,    19,    24,    28,    29,    25,     3,
       5,     6,     7,     9,     8,    10,    11,    12,    13,    14,
      15,     4,     0,     0,    30,   152,   155,    80,     0,     0,
       0,     0,     0,     0,     0,   147,    34,    35,    36,    37,
      38,    39,    85,    40,    41,    16,    17,    18,    31,    27,
      26,    74,   156,   157,   154,   132,   133,   130,   131,   134,
     135,   136,   137,   138,     0,     0,     0,   147,     0,   147,
     147,   139,   140,   141,     0,    91,     0,     0,     0,     0,
       0,    33,    82,    83,    84,    88,     0,     0,     0,     0,
     127,    48,   128,   129,   106,     0,     0,    51,     0,   106,
      95,   146,   151,    19,   149,    87,    86,     0,    73,     0,
      19,     0,     0,     0,    20,    90,    95,    20,     0,    20,
      20,     0,    18,     0,     0,     0,    18,     0,     0,   144,
     143,    77,   110,    19,    20,    49,     0,    19,    59,    56,
      42,    45,     0,     0,     0,     0,    60,    57,    58,    55,
      61,    62,    63,     0,    78,    92,     0,   102,    19,     0,
     158,   159,     0,     0,   160,   150,   148,   145,     0,    76,
       0,    72,     0,     0,   147,   113,   105,    89,    54,   147,
      50,    69,     0,    19,    65,    67,    19,    43,    46,    44,
      47,    98,    99,   100,   101,   147,     0,    93,    94,   106,
       0,   142,   109,   108,   111,   112,     0,     0,    52,     0,
      18,     0,    18,     0,    97,   119,     0,     0,     0,   116,
     121,   117,   124,   118,    20,    75,     0,    53,    71,     0,
      68,    66,    64,     0,     0,     0,     0,    79,   115,     0,
     104,     0,   104,   106,   120,   123,     0,   107,    70,     0,
       0,     0,   126,    20,   114,   106,   122,     0,   104,    20,
     125,    96,   103
  };

  const short int
  parser::yypgoto_[] =
  {
    -241,  -241,   -37,   -10,   -93,   -99,  -241,  -241,  -241,  -241,
      -2,  -241,  -241,  -241,  -125,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -111,  -241,  -241,  -241,  -241,   156,   171,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,    64,
    -241,  -241,  -241,  -241,  -240,  -107,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,   -43,  -241,   -41,   -53,   -34,  -241,  -241,
    -241,  -241,  -241,   -70,  -241,    78,  -241,  -241,   178,  -241
  };

  const short int
  parser::yydefgoto_[] =
  {
      -1,     1,    31,   156,    57,    58,    12,     4,     2,    11,
     142,     5,    14,    45,   157,   158,    46,    47,   127,   147,
     189,    48,   159,   160,   196,   161,   193,   162,   163,   120,
      49,    50,    51,    52,    95,   117,    53,   106,    54,   130,
     205,   168,   169,   206,   260,   124,   184,   143,   185,   216,
     257,   228,   229,   230,   231,   232,   251,   252,    79,    80,
      81,    82,    83,    91,   113,   114,    34,    35,    36,   175
  };

  const short int
  parser::yytable_[] =
  {
      32,    77,   129,    13,    78,    77,   174,   100,    87,   102,
     103,     3,   262,   165,   133,   115,   116,   183,   187,    -2,
     132,   137,    60,    61,   179,    55,    56,   136,   271,    84,
      85,    86,    15,    88,    89,   170,    16,   171,   150,    37,
      90,   192,   195,   150,   186,    38,    39,    17,   190,    18,
      40,    41,    42,   172,   173,    43,    44,    97,   172,   173,
      77,    77,    77,   121,   122,   123,   166,    33,   101,   207,
      96,   166,    92,    93,    94,    98,   208,   108,   197,   198,
     112,   -21,   -21,   -21,   -21,   -21,   119,     6,     7,     8,
       9,    10,   237,    99,   221,   125,   104,   223,   105,   235,
     220,    77,   234,   222,   182,   202,   203,   204,   238,   239,
     107,   241,   199,   200,   213,   214,   215,   226,   227,   218,
     109,   110,   112,   126,   178,   146,   180,   128,   167,    77,
     131,   134,   201,   135,   138,   224,   188,   -74,   258,   139,
     141,   140,   167,   145,   164,   264,   263,   177,   181,   197,
     199,    19,   148,   210,   149,   150,   151,   209,   269,   152,
     191,   211,   153,   212,   217,   219,   240,   242,   246,    77,
     154,   155,   233,   247,   243,    20,   244,   253,   249,    77,
     256,   261,   236,   259,   266,   265,   270,   268,   272,    62,
     144,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,    59,   254,    63,   255,    77,    77,   267,   250,
     176,    19,   148,    64,   149,   150,   151,     0,   245,   152,
       0,     0,   153,   194,    77,    20,   248,     0,     0,     0,
     154,   155,     0,     0,     0,    20,     0,     0,     0,     0,
       0,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,   148,     0,   149,   150,   151,     0,     0,   152,
       0,    19,   153,     0,     0,     0,     0,     0,     0,     0,
     154,   155,     0,     0,     0,    20,   111,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,     0,     0,     0,     0,     0,     0,     0,     0,
     118,    19,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,    19,     0,     0,     0,
       0,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,   225,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,   226,   227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76
  };

  const short int
  parser::yycheck_[] =
  {
      10,    38,   109,     5,    38,    42,   131,    77,    42,    79,
      80,     0,   252,    12,   113,    51,    52,   142,    12,     0,
     113,   120,    32,    33,   135,     9,    10,   120,   268,    39,
      40,    41,     4,    43,    44,     4,     4,     6,     7,    47,
      17,   152,   153,     7,   143,    53,    54,     4,   147,     4,
      58,    59,    60,    22,    23,    63,    64,    19,    22,    23,
      97,    98,    99,    97,    98,    99,    65,    21,    78,   168,
      11,    65,    48,    49,    50,    19,   169,    87,     7,     8,
      90,    24,    25,    26,    27,    28,    96,    24,    25,    26,
      27,    28,   217,    19,   193,   105,    11,   196,    57,   210,
     193,   138,   209,   196,   138,    44,    45,    46,   219,   220,
      11,   222,     7,     8,   184,    61,    62,    42,    43,   189,
      11,    11,   132,    11,   134,   127,   136,    13,   130,   166,
      13,    55,   166,    13,     9,   205,   146,    11,   249,    20,
      12,    20,   144,    12,    12,   256,   253,    18,    12,     7,
       7,     3,     4,    13,     6,     7,     8,    11,   265,    11,
      12,    20,    14,    16,    13,    16,    12,    15,     9,   206,
      22,    23,   206,    12,    19,    27,    19,    17,    16,   216,
      13,     9,   216,    56,    20,    17,    20,    18,    18,    33,
     126,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     3,     4,   246,    33,   246,   243,   244,   261,   243,
     132,     3,     4,    35,     6,     7,     8,    -1,   228,    11,
      -1,    -1,    14,    15,   261,    27,   236,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     3,     4,    -1,     6,     7,     8,    -1,    -1,    11,
      -1,     3,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    27,    18,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      12,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,     3,    -1,    -1,    -1,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,     3,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    67,    74,     0,    73,    77,    24,    25,    26,    27,
      28,    75,    72,    76,    78,     4,     4,     4,     4,     3,
      27,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    68,    69,    21,   132,   133,   134,    47,    53,    54,
      58,    59,    60,    63,    64,    79,    82,    83,    87,    96,
      97,    98,    99,   102,   104,     9,    10,    70,    71,     4,
      69,    69,    93,    94,   134,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    68,   123,   124,
     125,   126,   127,   128,    69,    69,    69,   123,    69,    69,
      17,   129,    48,    49,    50,   100,    11,    19,    19,    19,
     129,    69,   129,   129,    11,    57,   103,    11,    69,    11,
      11,    18,    69,   130,   131,    51,    52,   101,    12,    69,
      95,   123,   123,   123,   111,    69,    11,    84,    13,   111,
     105,    13,    70,    71,    55,    13,    70,    71,     9,    20,
      20,    12,    76,   113,   105,    12,    76,    85,     4,     6,
       7,     8,    11,    14,    22,    23,    69,    80,    81,    88,
      89,    91,    93,    94,    12,    12,    65,    76,   107,   108,
       4,     6,    22,    23,    80,   135,   131,    18,    69,    88,
      69,    12,   123,    80,   112,   114,    71,    12,    69,    86,
      71,    12,    88,    92,    15,    88,    90,     7,     8,     7,
       8,   123,    44,    45,    46,   106,   109,    71,    70,    11,
      13,    20,    16,   129,    61,    62,   115,    13,   129,    16,
      70,    71,    70,    71,   129,    29,    42,    43,   117,   118,
     119,   120,   121,   123,   111,    88,   123,    80,    88,    88,
      12,    88,    15,    19,    19,    69,     9,    12,    69,    16,
     123,   122,   123,    17,   119,   121,    13,   116,    88,    56,
     110,     9,   110,   111,    88,    17,    20,   122,    18,   111,
      20,   110,    18
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    66,    67,    68,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    70,    70,    71,    71,
      72,    73,    74,    74,    75,    75,    75,    75,    75,    75,
      76,    77,    77,    78,    79,    79,    79,    79,    79,    79,
      79,    79,    80,    80,    80,    81,    81,    81,    82,    83,
      84,    84,    85,    86,    86,    87,    88,    88,    88,    88,
      88,    88,    88,    88,    89,    89,    90,    90,    91,    91,
      92,    92,    93,    93,    94,    95,    95,    96,    97,    98,
      99,    99,   100,   100,   100,   100,   101,   101,   101,   102,
     103,   103,   104,   105,   105,   105,   106,   107,   108,   109,
     109,   109,   109,   110,   110,   111,   111,   112,   113,   114,
     114,   115,   115,   115,   116,   116,   117,   117,   117,   117,
     118,   118,   119,   120,   120,   121,   122,   123,   123,   123,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   125,
     125,   125,   126,   127,   128,   129,   129,   129,   130,   130,
     131,   131,   132,   132,   133,   133,   134,   134,   135,   135,
     135
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       0,     0,     3,     0,     2,     2,     3,     3,     2,     2,
       2,     3,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     2,     2,     3,     5,
       3,     0,     3,     3,     1,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     2,     3,     1,     4,     2,
       5,     3,     5,     3,     1,     5,     3,     5,     5,     8,
       1,     0,     1,     1,     1,     0,     1,     1,     0,     6,
       2,     0,     5,     3,     3,     0,     7,     3,     2,     1,
       1,     1,     0,     4,     0,     3,     0,     5,     3,     2,
       0,     1,     1,     0,     2,     0,     1,     1,     1,     1,
       3,     1,     5,     3,     1,     6,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     6,     4,     4,     4,     2,     0,     3,     1,
       3,     1,     1,     0,     2,     1,     2,     2,     1,     1,
       1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "tok_eof", "error", "$undefined", "tok_identifier", "tok_literal",
  "tok_doctext", "tok_bool_constant", "tok_int_constant",
  "tok_dub_constant", "\",\"", "\";\"", "\"{\"", "\"}\"", "\"=\"", "\"[\"",
  "\"]\"", "\":\"", "\"(\"", "\")\"", "\"<\"", "\">\"", "\"@\"", "\"+\"",
  "\"-\"", "tok_include", "tok_cpp_include", "tok_hs_include",
  "tok_package", "tok_namespace", "tok_void", "tok_bool", "tok_byte",
  "tok_string", "tok_binary", "tok_i16", "tok_i32", "tok_i64",
  "tok_double", "tok_float", "tok_map", "tok_list", "tok_set",
  "tok_stream", "tok_sink", "tok_oneway", "tok_idempotent", "tok_readonly",
  "tok_safe", "tok_transient", "tok_stateful", "tok_permanent",
  "tok_server", "tok_client", "tok_typedef", "tok_struct", "tok_exception",
  "tok_throws", "tok_extends", "tok_service", "tok_enum", "tok_const",
  "tok_required", "tok_optional", "tok_union", "tok_interaction",
  "tok_performs", "$accept", "Program", "FieldTypeIdentifier",
  "Identifier", "CommaOrSemicolon", "CommaOrSemicolonOptional",
  "CaptureDocText", "DestroyDocText", "HeaderList", "Header",
  "DefinitionAttrs", "DefinitionList", "DefinitionAnnotated", "Definition",
  "Integer", "Double", "Typedef", "Enum", "EnumValueList",
  "EnumValueAnnotated", "EnumValue", "Const", "ConstValue", "ConstList",
  "ConstListContents", "ConstMap", "ConstMapContents", "ConstStruct",
  "ConstStructType", "ConstStructContents", "Struct", "Union", "Exception",
  "ErrorSafety", "ErrorKind", "ErrorBlame", "Service", "Extends",
  "Interaction", "FunctionList", "Function", "FunctionAnnotated",
  "Performs", "FunctionQualifier", "MaybeThrows", "FieldList", "Field",
  "FieldAnnotated", "FieldId", "FieldQualifier", "FieldValue",
  "FunctionType", "ResponseAndStreamReturnType", "StreamReturnType",
  "ResponseAndSinkReturnType", "SinkReturnType", "SinkFieldType",
  "FieldType", "BaseType", "ContainerType", "MapType", "SetType",
  "ListType", "Annotations", "AnnotationList", "Annotation",
  "StructuredAnnotations", "NonEmptyStructuredAnnotationList",
  "StructuredAnnotation", "IntOrLiteral", YY_NULLPTR
  };


  const unsigned short int
  parser::yyrline_[] =
  {
       0,   303,   303,   318,   321,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   336,   337,   340,   341,
     343,   346,   351,   352,   355,   360,   365,   372,   379,   386,
     393,   404,   410,   413,   422,   423,   424,   425,   426,   427,
     428,   429,   432,   437,   442,   449,   454,   459,   466,   474,
     483,   490,   496,   505,   512,   520,   528,   534,   539,   545,
     550,   555,   560,   565,   572,   577,   585,   591,   600,   605,
     613,   619,   628,   634,   643,   650,   656,   665,   674,   684,
     698,   699,   702,   703,   704,   705,   708,   709,   710,   713,
     722,   727,   730,   739,   745,   752,   758,   775,   784,   801,
     802,   803,   804,   807,   812,   815,   822,   828,   839,   848,
     849,   852,   853,   854,   857,   866,   869,   874,   879,   884,
     891,   897,   904,   913,   919,   926,   936,   943,   948,   953,
     960,   965,   970,   975,   980,   985,   990,   995,  1000,  1007,
    1008,  1009,  1012,  1019,  1026,  1033,  1038,  1043,  1046,  1053,
    1063,  1068,  1075,  1080,  1083,  1089,  1097,  1102,  1112,  1117,
    1124
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 95 "parse/thrifty.yy" // lalr1.cc:1167
} } } } // apache::thrift::compiler::yy
#line 3014 "/builddir/build/BUILD/fbthrift-2022.02.21.00/thrift/compiler/thrifty.cc" // lalr1.cc:1167
#line 1132 "parse/thrifty.yy" // lalr1.cc:1168


/**
 * Method that will be called by the generated parser upon errors.
 */
void apache::thrift::compiler::yy::parser::error(const location_type&, std::string const& message) {
  /*
   * TODO(urielrivas): Pass the location as argument to yyerror.
   */
  driver.yyerror(message);
}
